每天一道leetcode:1466. 重新规划路线(图论&中等&广度优先遍历)

今日份题目:

n 座城市,从 0 到 n-1 编号,其间共有 n-1 条路线。因此,要想在两座不同城市之间旅行只有唯一一条路线可供选择(路线网形成一颗树)。去年,交通运输部决定重新规划路线,以改变交通拥堵的状况。

路线用 connections 表示,其中 connections[i] = [a, b] 表示从城市 a 到 b 的一条有向路线。

今年,城市 0 将会举办一场大型比赛,很多游客都想前往城市 0 。

请你帮助重新规划路线方向,使每个城市都可以访问城市 0 。返回需要变更方向的最小路线数。

题目数据 保证 每个城市在重新规划路线方向后都能到达城市 0 。

示例1

复制代码
输入:n = 6, connections = [[0,1],[1,3],[2,3],[4,0],[4,5]]
输出:3
解释:更改以红色显示的路线的方向,使每个城市都可以到达城市 0 。

示例2

复制代码
输入:n = 5, connections = [[1,0],[1,2],[3,2],[3,4]]
输出:2
解释:更改以红色显示的路线的方向,使每个城市都可以到达城市 0 。

示例3

复制代码
输入:n = 3, connections = [[1,0],[2,0]]
输出:0

提示

  • 2 <= n <= 5 * 10^4

  • connections.length == n-1

  • connections[i].length == 2

  • 0 <= connections[i][0], connections[i][1] <= n-1

  • connections[i][0] != connections[i][1]

题目思路

这道题我们使用bfs广度优先遍历 。拿例1为例,我们只需要从0开始遍历,由于路径单向通行,故与这些点的连线都需要反向,除此之外,下边那条边直接找是无法从0走过去的,但还有条路需要反向,这时,我们引入反向图,在正向bfs的同时对反向图同样bfs,放入同一个队列中,这样就可以保证图中所有不满足条件的边都被记录下来了。

所谓反向图,就是将图中所有的路径反向,(i,j)处的值与(j,i)处的值交换。

代码

cpp 复制代码
class Solution 
{
public:
    int minReorder(int n, vector<vector<int>>& connections) 
    {
        vector<vector<int> > graph(n);//正向图
        vector<vector<int> > antigraph(n);//反向图
        
        for(auto& c:connections) 
        {
            graph[c[0]].push_back(c[1]);//记录正向图
            antigraph[c[1]].push_back(c[0]);//记录反向图
        }

        int ans=0;
        int visited[100000]={0};
        visited[0]=1;
        queue<int> p;
        p.push(0);
        //bfs
        while(!p.empty()) 
        {
            //获取当前点信息
            int i=p.front();
            p.pop();

            //正向遍历搜寻结果
            for(int j=0;j<graph[i].size();j++)
            {
                if(visited[graph[i][j]]==0) 
                {
                    visited[graph[i][j]]=1;//标记为已到达过
                    ans++;//0向外能到达的点的路径就是需要反向的路径
                    p.push(graph[i][j]);
                }
            }

            //反向遍历搜寻结果
            for(int j=0;j<antigraph[i].size();j++)
            {
                if(visited[antigraph[i][j]]==0) 
                {
                    visited[antigraph[i][j]]=1;//标记为已到达过
                    p.push(antigraph[i][j]);
                } 
            }            
        }
        return ans;
    }
};

提交结果

欢迎大家在评论区讨论,如有不懂的代码部分,欢迎在评论区留言!

相关推荐
剑胆凌锋8 小时前
等级保护测评工程师的困境
网络·安全·web安全·网络安全·职场和发展
朝朝辞暮i10 小时前
C++ 第 21 课:struct —— 把一组相关数据打包在一起
开发语言·c++·算法
青梅橘子皮10 小时前
Blue---二分算法(二分查找与二分答案)
算法
长河10 小时前
Java的GC(垃圾回收)中,标记无用对象的核心方法是可达性分析算法
java·jvm·算法
月光船幽幽10 小时前
加性偏移外推提升参数识别可靠性
python·算法
是翎11 小时前
AI开发工程师面试指南
人工智能·面试·职场和发展
H.莓飛11 小时前
【数据结构】队列
linux·数据结构·centos
Ivanqhz11 小时前
层归一化、残差、前馈网络与激活函数简述
服务器·数据库·人工智能·深度学习·算法
不会就选b12 小时前
算法日常・每日刷题--<动态规划>3
数据结构·算法
Interview Aid11212 小时前
Amazon SDE Interview Process:OA、VO 与面试流程详解
面试·职场和发展